
		.if (JIFFYDOS_ACCEL=1) & (SUPERCPU=0)

iecout		.proc			;eddd
		bit SerialOutBufFlag
		bmi ie			;Anything in buffer?
		sec
		ror SerialOutBufFlag
		gmi la
ie		pha
		jsr jiffy_fbfe
		pla
la		sta SerialOutBuf
		clc
		rts
		.pend

iecsecond	.proc			;edb9
		sta SerialOutBuf
		jsr iec_ed36
		jmp $edbe		;atnhi
		.pend

iectksa		.proc			;edc7
		sta SerialOutBuf
		jsr iec_ed36
		jmp $edcc		;wait for clock
		.pend

jiffy_f0ed	.proc
		lda #0
		sta Jiffyflag
		jmp $ee97		;datahi
		.pend

iecuntalk	.proc			;edef
		sei
		lda $dd00		;atnlo
		ora #$08
		sta $dd00
		jsr $ee8e		;clklo
		lda #$5f
		.byte SKIP2

iecunlisten	.proc			;edfe
		lda #$3f
		jsr iec_ed11
		jmp $ee03
		.pend

jiffy_fbfe	.proc			;JiffyDos send
		bit Jiffyflag
		bvc ms			;jiffydrive?
jf		lda $d015
		beq ss
		pha
		jsr jiffy_f0d8		;spriteoff
		jsr ss
		pla
		sta $d015
		rts

ms		lda Jiffyflag
		cmp #$a0
		bcs jf
		gcc iecsend

ss		txa
		pha
		lda SerialOutBuf
		and #$f0
		pha
		lda SerialOutBuf
		and #$0f
		tax
		lda $dd00
		bpl *-3
		sei
		and #7
		sta SerialOutBuf
		.page                   ;CMD HD SAVE?
iw		sec
		lda $d012
		sbc #$27
                bcc kk
		sbc $d011
		and #7
		beq iw
kk		lda SerialOutBuf
		.endp
		.comment
                sec
iw              lda $d012
                sbc $d011
                and #7
                cmp #6
                bcs iw
                lda SerialOutBuf
                .endc
		sta $dd00
		pla
		ora SerialOutBuf
		sta $dd00
		lsr
		lsr
		and #$f0
		ora SerialOutBuf
		sta $dd00
		lda tb,x
		ora SerialOutBuf
		sta $dd00
		lsr
		lsr
		and #$f0
		ora SerialOutBuf
		sta $dd00
		and #$0f
		bit Jiffyflag
		bmi *+4
		ora #$10
		sta $dd00
		pla
		tax
		lda SerialOutBuf
		ora #$10
		sta $dd00
		bit $dd00
		bmi iectimeout
		cli
		rts

tb		.byte $00,$80,$20,$a0,$40,$c0,$60,$e0
		.byte $10,$90,$30,$b0,$50,$d0,$70,$f0
		.pend

iecdevnotp	jmp $edad		;device not present
iectimeout      jmp $edb0		;timeout

iectalk		.proc			;ed09
		ora #$40
		.byte SKIP2

ieclisten	.proc			;ed0c
		ora #$20
                
                pha
                lda $02a1
                beq sb
re              lda $02a1
                and #$03
                bne re			;jsr $f0a4 serial bus idle inlined
                lda #$10		;because of Dolphin DOS
                sta $dd0d
                lda #$00
                sta $02a1
sb              pla

iec_ed11	.proc			;ed11
		bit SerialOutBufFlag
		bpl atr
		pha
		sec
		ror Jiffyflag
		jsr jiffy_fbfe
		lsr SerialOutBufFlag
;		lsr Jiffyflag
		pla
atr		sta SerialOutBuf
		sei
		jsr jiffy_f0ed		;clear Jiffyflag and datahi
		cmp #$3f
		bne *+5
		jsr $ee85		;clkhi
		lda $dd00		;atnlo
		ora #8
		sta $dd00

iec_ed36	.proc			;ed36
		sei
		jsr $ee8e		;clklo
		jsr $ee97		;datahi
		jsr $eeb3		;1ms delay

iecsend		.proc
		sei			;ed40
		jsr $ee97		;datahi
		jsr $eea9		;getdataclk
		bcs iecdevnotp		;data low?
		jsr $ee85		;clkhi
		bit Jiffyflag
		bpl id
		jsr $eea9		;getdataclk
		bcc *-3			;wait datahi
		jsr $eea9		;getdataclk
		bcs *-3			;wait datalo
id		jsr $eea9		;getdataclk
		bcc *-3			;wait datahi
		jsr $ee8e		;clklo
		lda #8
		sta $a5
jw		lda $dd00
		cmp $dd00
		bne jw
		ora #0
		bpl iectimeout

		cmp (0,x)
                ror SerialOutBuf

		and #$df
		bcs *+4
		ora #$20		;datalo (send bit)
		sta $dd00
		jsr $ee85		;clkhi
                jsr $ee8d		;wait
		and #$df
		ora #$10
		sta $dd00
		and #$08
		beq ex			;addressing?

		lda $a5
		eor #$02
		bne ex			;last bit?

		lda #$1e+1
sc		bit $dd00
		bpl ll
		sbc #1
		bne sc
		geq ex

ll		bit $dd00
		bpl *-3
		lda SerialOutBuf
		sec
		ror
		ror
		sta Jiffyflag  		;jiffydrive found!
ex
		dec $a5
		bne jw
		geq $ed92
		.pend

iecin		.proc			;fbaa JiffyDos get
		bit Jiffyflag
		bvc old			;jiffy drive?
		lda $d015
		beq lp
		pha
		jsr jiffy_f0d8		;spriteoff
		jsr lp
		pla
		sta $d015
		lda SerialInBuf
		rts

old		sei
		lda #$00
		jmp $ee16

lp		lda $dd00		;fbb4
		cmp #$40
		bcc lp
		sei
		and #7
		pha
                .page
lp2		sec
		lda $d012
		sbc #$27
                bcc kk
		sbc $d011
		and #7
		beq lp2
kk		.endp
		pla
		sta $dd00
                sta SerialInBuf
		ora #$20
		pha
                nop
                nop
		ora $dd00
		lsr
		lsr
		nop
		ora $dd00
		lsr
		lsr
		eor SerialInBuf
		eor $dd00
		lsr
		asr #$fe
		eor SerialInBuf
		eor $dd00
		sta SerialInBuf
		pla
		bit $dd00
		sta $dd00
		bvc exit
		bpl last
		lda #$42
		jmp $edb2

last		lda #$40
		jsr $fe1c
exit		cli
		lda SerialInBuf
		rts
		.pend

		.fi

jiffy_f0d8	.proc			;sprite off and delay
		#lda0
		sta $d015
lp		adc #1
		bne lp
		rts
		.pend

